/*
 * <dinamic.c>
 */


#include "sqlibf.h"


//
// TEST_DINAMIC _______________________________________________________________
//
// Uso: Busca los parametros dinamicos
//

int test_dinamic(struct cracked_url cu, int param) {
  struct query_string *ptr_param;
  int counter=1;
  int dinamic_num=0;


  IMPRIME("[ 1.0 ] Testing Dynamic Parameters\n");

  ptr_param=cu.url_params;

  while(counter<=cu.param_num) {
    if(ptr_param->siguiente==0) ptr_param=cu.post_params;
    if(counter==param || param==0) ptr_param->is_dinamic=isdinamic(cu, counter);
    if(ptr_param->is_dinamic) dinamic_num++;

    if(ptr_param->is_dinamic==DINAMIC_KEY) strncpy(ptr_param->my_keyword, key_word, WORD_SIZE-1);
    ptr_param->error_words=base_error.body_words;
    ptr_param->error_lines=base_error.body_lines;

    ptr_param=ptr_param->siguiente;
    counter++;
    }

  return dinamic_num;

}


//
// ISDINAMIC __________________________________________________________________
//
// Uso: Comprueba si el parametro dado es dinamico
//

int isdinamic(struct cracked_url cu, int num) {
  struct assembled_url url;
  struct result resultado;
  int comparacion=0;
  int i;


  IMPRIME("[ 1.%d.1 ] Testing Dynamics in Parameter: '%s'\n", num, variable_name(cu, num));

  url=assemble_url(cu, num, ",'\"QnoVale");
  resultado=get_url(url); free(url.url); free(url.post);

  base_error=resultado;

  if(resultado.body_size==base_result.body_size) {
    IMPRIME("--> PARAMETER '%s' IS NOT ANALYZABLE\n", variable_name(cu, num));
    return STATIC;
    }


  IMPRIME("[ 1.%d.2 ] Confirming Dynamics in Parameter: '%s'\n", num, variable_name(cu, num));

  url=assemble_url(cu, num, ".0-2");
  resultado=get_url(url); free(url.url); free(url.post);


  // KEY_WORD

  for(i=0;i<resultado.word_count;i++) {
    strncpy(base_error.word_list[base_error.word_count], resultado.word_list[i], WORD_SIZE-1);
    if(base_error.word_count>LIST_SIZE-2) i=resultado.word_count;
      else base_error.word_count++;
    }

  if(options.debuging>2) IMPRIME("++ isdinamic() WORD_COUNT: %d\n", base_error.word_count);

  qsort(base_error.word_list, base_error.word_count, WORD_SIZE, (void *)strcmp);
  strncpy(key_word, get_diferent(base_result.word_list, base_error.word_list, base_result.word_count, base_error.word_count), WORD_SIZE-1);

  if(strlen(key_word)) {
    if(options.debuging>1) IMPRIME("+ isdinamic() KEY_WORD: %s\n", key_word);
    IMPRIME("--> PARAMETER '%s' IS DYNAMIC\n", variable_name(cu, num));
    return DINAMIC_KEY;
    }


  // LINES/WORDS

  if(options.test_type==WORDS || options.test_type==KEY_WORD) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);

  if(comparacion>0) {
    IMPRIME("--> PARAMETER '%s' IS DYNAMIC (lines/words)\n", variable_name(cu, num));
    return DINAMIC_LW;
    }


  IMPRIME("--> PARAMETER '%s' IS DYNAMIC but NOT ANALYZABLE\n", variable_name(cu, num));
  return STATIC;

}



