/*
 * <extra.c>
 */


#include "sqlibf.h"


//
// EXTRA ______________________________________________________________________
//
// Uso: Comprobaciones adicionales
//

int extra(struct cracked_url cu) {
  struct query_string *ptr_param;
  int counter=1;
  int unible_num=0;
  int original=0;


  IMPRIME("[ 4.0 ] Doing Extra Tests\n");

  // Check_parentesis

  ptr_param=cu.url_params;

  while(counter<=cu.param_num) {
    if(ptr_param->siguiente==0) ptr_param=cu.post_params;
    if(ptr_param->is_injectable) {

      base_error.body_words=ptr_param->error_words;
      base_error.body_lines=ptr_param->error_lines;
      if(ptr_param->is_dinamic==DINAMIC_KEY) strncpy(key_word, ptr_param->my_keyword, WORD_SIZE-1);
      if(ptr_param->is_dinamic==DINAMIC_LW && options.test_type==KEY_WORD) { options.test_type=LINES; original=KEY_WORD; }

      ptr_param->terminator=FINGER;
      ptr_param->parentesis=check_parentesis(cu, counter);

      if(original) options.test_type=KEY_WORD;
      }
    ptr_param=ptr_param->siguiente;
    counter++;
    }


  // Check_terminators

  counter=1;
  ptr_param=cu.url_params;

  while(counter<=cu.param_num) {
    if(ptr_param->siguiente==0) ptr_param=cu.post_params;
    if(ptr_param->is_injectable) {

      base_error.body_words=ptr_param->error_words;
      base_error.body_lines=ptr_param->error_lines;
      if(ptr_param->is_dinamic==DINAMIC_KEY) strncpy(key_word, ptr_param->my_keyword, WORD_SIZE-1);
      if(ptr_param->is_dinamic==DINAMIC_LW && options.test_type==KEY_WORD) { options.test_type=LINES; original=KEY_WORD; }

      ptr_param->terminator=check_terminator(cu, counter);
      if(ptr_param->terminator) unible_num++;

      if(original) options.test_type=KEY_WORD;
      }
    ptr_param=ptr_param->siguiente;
    counter++;
    }

  return unible_num;

}


//
// CHECK_PARENTESIS
//
// Uso: Comprueba si el parametro necesita ser cerrado mediante parentesis
//

int check_parentesis(struct cracked_url cu, int num) {
  struct assembled_url au;
  struct result resultado;
  int comparacion=0;


  IMPRIME("[ 4.%d.0 ] Checking if we need ')' in parameter: '%s'\n", num, variable_name(cu, num));

  au=assemble_url(cu, num, ") and (");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> PARENTESIS Needed in Parameter: '%s'\n", variable_name(cu, num));
    return 1;
    }


  IMPRIME("[ 4.%d.1 ] Checking if we need '))' in parameter: '%s'\n", num, variable_name(cu, num));

  au=assemble_url(cu, num, ")) and ((");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> DOUBLE PARENTESIS Needed in Parameter: '%s'\n", variable_name(cu, num));
    return 2;
    }

  return 0;

}


//
// CHECK_TERMINATOR ___________________________________________________________
//
// Uso: Comprueba si la sentencia sql inyectada puede ser cerrada con algun terminador
//

int check_terminator(struct cracked_url cu, int num) {
  struct assembled_url au;
  struct result resultado;
  int comparacion;


  IMPRIME("[ 5.%d.0 ] Trying to get a valid SQL terminator in parameter: '%s'\n", num, variable_name(cu, num));


  IMPRIME("[ 5.%d.1 ] Trying '--'\n", num);

  au=assemble_url(cu, num, "--novale");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with '--' WORKS in Parameter: '%s'\n", variable_name(cu, num));
    return GG;
    }


  IMPRIME("[ 5.%d.2 ] Trying '/*'\n", num);

  au=assemble_url(cu, num, "/*novale");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with '/*' WORKS in Parameter: '%s'\n", variable_name(cu, num));
    return BA;
    }


  IMPRIME("[ 5.%d.3 ] Trying ';' (%%3B)\n", num);

  au=assemble_url(cu, num, "%3Bnovale"); // ';'

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with ';' (%%3B) WORKS in Parameter: '%s'\n", variable_name(cu, num));
    return PC;
    }


  IMPRIME("[ 5.%d.4 ] Trying '#' (%%23)\n", num);

  au=assemble_url(cu, num, "%23novale"); // '#'

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with '#' (%%23) WORKS in Parameter: '%s'\n", variable_name(cu, num));
    return HA;
    }


  IMPRIME("[ 5.%d.5 ] Trying NULL byte (%%00)\n", num);

  au=assemble_url(cu, num, "%00novale");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with NULL byte (%%00) WORKS in Parameter: '%s'\n", variable_name(cu, num));
    IMPRIME("(!) WARNING: This can be a false positive on some systems.\n");
    // IIS/ASP, MS Access, DB2
    return NL;
    }

/*
  IMPRIME("[ 5.%d.6 ] Trying ')--'\n", num);

  au=assemble_url(cu, num, ")--novale");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with ')--' WORKS in Parameter: '%s'\n", variable_name(cu, num));
    return P1;
    }


  IMPRIME("[ 5.%d.7 ] Trying '))--'\n", num);

  au=assemble_url(cu, num, "))--novale");

  resultado=get_url(au); free(au.url); free(au.post);

  if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
  if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

  if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
    IMPRIME("==> CLOSING with '))--' WORKS in Parameter: '%s'\n", variable_name(cu, num));
    return P2;
    }
*/

  IMPRIME("==> CAN'T FIND a valid SQL terminator in Parameter '%s'\n", variable_name(cu, num));
  return 0;

}




