/*
 * <get_url.c>
 */


#include "sqlibf.h"


// Local Globales

struct result estructura;

void *html_body;
size_t html_size;


//
// GET_URL
//
// Uso: Descarga una URL y devuelve una estrcutra con el resultado
//

struct result get_url(struct assembled_url au) {
  char host_header[STRING_SIZE];
  struct curl_slist *slist;


  if(options.debuging>1) {
    IMPRIME("+ get_url() GETTING URL: %s\n", au.url);
    if(do_post) IMPRIME("+ POST: %s\n", au.post);
    }


// Inicializamos

  errores=0;


retry:

  memset(&estructura, 0, sizeof(struct result));
  memset(host_header, 0, STRING_SIZE);
  strncpy(estructura.url, au.url, STRING_SIZE-1);
  strncpy(estructura.post, au.post, STRING_SIZE-1);
  estructura.body_size=0;
  estructura.head_size=0;
  estructura.body_lines=0;
  estructura.head_lines=1;
  estructura.estado=-1;
  slist=0;
  html_size=0;

  html_body=malloc(STRING_SIZE);

  estructura.word_count=0;


// Lanzamos la peticion

  if(curl) {
    curl_easy_setopt(curl, CURLOPT_URL, au.url);
    curl_easy_setopt(curl, CURLOPT_NOPROGRESS, 1);
    curl_easy_setopt(curl, CURLOPT_TIMEOUT, TIMEOUT);
    curl_easy_setopt(curl, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.1.4322)");
    curl_easy_setopt(curl, CURLOPT_HEADERFUNCTION, get_header);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, get_body);

    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0);
    curl_easy_setopt(curl, CURLOPT_SSL_VERIFYHOST, 0);

    if(do_post) curl_easy_setopt(curl, CURLOPT_POSTFIELDS, au.post);

    if(strlen(options.header)>2) {
      slist = curl_slist_append(slist, options.header);
      curl_easy_setopt(curl, CURLOPT_HTTPHEADER, slist);
      }

    estructura.estado=curl_easy_perform(curl);

    curl_easy_getinfo(curl, CURLINFO_HTTP_CODE, &estructura.codigo_http);

    } else {

    if(options.debuging>3) IMPRIME("+++ get_url() libcurl failed\n");

  }


  /* Controlamos el resultado */

  if(estructura.codigo_http==0) {
    errores++;

    if(options.debuging>2) IMPRIME("++ get_url() error: %d\n", estructura.estado);

    if(errores>=MAX_FAILS) {
      IMPRIME("                                                                               \r");
      IMPRIME("\n(!) FATAL: Too many errors conecting to host\n");
      exit(-1);
    }

    goto retry;

  }


  /* Analizamos el cuerpo html */

  if(html_size>0) crack_body();


  /* devolvemos la estructura */

  if(options.debuging>1) {
    //IMPRIME("+ U: %s\n", estructura.url);
    if(do_post) IMPRIME("+ P: %s\n", estructura.post);
    //IMPRIME("ESTADO: %d\n", estructura.estado);
    IMPRIME("+ CODIGO_HTTP: %d - ", estructura.codigo_http);
    //IMPRIME("HEAD_SIZE: %d\n", estructura.head_size);
    //IMPRIME("HEAD_LINES: %d\n", estructura.head_lines);
    IMPRIME("BODY_SIZE: %d - ", estructura.body_size);
    IMPRIME("BODY_WORDS: %d - ", estructura.body_words);
    IMPRIME("BODY_LINES: %d\n\n", estructura.body_lines);
    //IMPRIME("LOCATION: %s\n", estructura.location);
    //IMPRIME("SERVER: %s\n", estructura.server);
  }

  return estructura;

}



//
// GET_HEADER
//
// Uso: Funcion de manejo de las cabeceras
//

size_t get_header(void *ptr, size_t size, size_t nmemb, void *stream) {
  int len;
  int i;


  len=size*nmemb;

  /* DEBUG */

  if(options.debuging==30) IMPRIME("+++++ get_header() LEN: %d\n", len);
  if(options.debuging==30) IMPRIME("++++++ get_header() HEADERS: %s\n", (char *)ptr);


  // Tamao

  estructura.head_size+=len;


  // Numero de lineas

  for(i=0;i<len;i++) {
    if(strncmp(ptr+i, "\n", 1)==0) estructura.head_lines++;
  }

  return len;

}




//
// GET_BODY
//
// Uso: Funcion de manejo del cuerpo HTML
//

size_t get_body(void *ptr, size_t size, size_t nmemb, void *stream) {
  int len;

  len=size*nmemb;


  /* DEBUG */

  if(options.debuging==30) IMPRIME("+++++ get_body() LEN: %d\n", len);

  if(options.debuging==30) { puts(ptr); IMPRIME("+++++++++\n"); }


  /* Copiamos al buffer */

  html_body=realloc(html_body, html_size+len);

  memcpy(html_body+html_size, ptr, len);

  html_size+=len;

  return len;

}


//
// CRACK_BODY
//
// Uso: Analisis del cuerpo HTML
//

int crack_body() {
  int in_word=0;

  int in_tag=0;
  int in_html=0;

  char wbuffer[STRING_SIZE];
  char cbuffer[STRING_SIZE];

  int i;
  int c;
  int error;

  char uno;
  char word[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

  void *ptr;

  ptr=html_body;
  memset(wbuffer, 0 , STRING_SIZE);
  memset(cbuffer, 0 , STRING_SIZE);


  // Buscamos mensajes de error

  if(analiza_html) {

    error=search(ptr);

    if(error) {
      db_from_error=error;
      if(options.debuging>1) IMPRIME("+ crack_body() Error Message FOUND From: %d\n", db_from_error);
    }

  }


  // Contamos bytes, palabras y lineas

  for(i=0;i<html_size;i++) {

  estructura.body_size++;
    c=(char)*(char *)(ptr+i);

    switch(c) {
      case '\n':
        estructura.body_lines++;
      case '\r':
      case '\f':
      case '\t':
      case ' ':
      case '\v':
        if(in_word) {
          in_word = 0;
          estructura.body_words++;
        }
        break;
      default:
        in_word = 1;
        break;
    }

  }


  // Sacamos el texto HTML

  for(i=0;i<html_size;i++) {

    uno=(char)*(char *)(ptr+i);

    // Estamos en el texto

    if(!in_tag) {
      if(strchr(word, uno)) {
        if(strlen(wbuffer)<STRING_SIZE-1) strncat(wbuffer, &uno, 1);
        in_html=1;
        } else {
        if(in_html==1) {
          strncat(wbuffer, "\x00", 1);
          if(strlen(wbuffer)>4 && estructura.word_count<LIST_SIZE-1) {
            if(options.debuging==30) IMPRIME("++++++ WORD: %s\n", wbuffer);
            strncpy(estructura.word_list[estructura.word_count], wbuffer, WORD_SIZE-1);
            estructura.word_count++;
          }
          memset(wbuffer, 0, STRING_SIZE);
        }
        in_html=0;
      }
    }

    // Analisis del tag html

    if(uno=='<') { in_tag=1; in_html=0; }

    if(uno=='>') in_tag=0;

  }


  // Fin

  // free(html_body);


  qsort(estructura.word_list, estructura.word_count, WORD_SIZE, (void *)strcmp);

  if(options.debuging>2) IMPRIME("++ crack_body() WORD_COUNT: %d\n", estructura.word_count);

  //IMPRIME("Sorted array:\n");
  //for (i=0; i<estructura.word_count; i++) IMPRIME("%s\n",estructura.word_list[i]);

  return 0;

}



