/*
 * <inject.c>
 */


#include "sqlibf.h"


//
// TEST_INJECT _______________________________________________________________
//
// Uso: Busca los parametros inyectables
//

int test_inject(struct cracked_url cu) {
  struct query_string *ptr_param;
  int counter=1;
  int inject_num=0;
  int original=0;


  IMPRIME("[ 2.0 ] Testing Injectable Parameters\n");

  ptr_param=cu.url_params;

  while(counter<=cu.param_num) {
    if(ptr_param->siguiente==0) ptr_param=cu.post_params;
    if(ptr_param->is_dinamic) {

      base_error.body_words=ptr_param->error_words;
      base_error.body_lines=ptr_param->error_lines;
      if(ptr_param->is_dinamic==DINAMIC_KEY) strncpy(key_word, ptr_param->my_keyword, WORD_SIZE-1);
      if(ptr_param->is_dinamic==DINAMIC_LW && options.test_type==KEY_WORD) { options.test_type=LINES; original=KEY_WORD; }

      ptr_param->is_injectable=isinject(cu, counter);
      if(ptr_param->is_injectable) inject_num++;

      // OJO: aadir test de lines/words por cada variable
      if(original) options.test_type=KEY_WORD;

      }
    ptr_param=ptr_param->siguiente;
    counter++;
    }

  return inject_num;

}


//
// ISINJECT ___________________________________________________________________
//
// Uso: Comprueba si el parametro es inyectable
//

int isinject(struct cracked_url cu, int num) {
  struct assembled_url au;
  struct result resultado;
  int comparacion;


  // 1) Unescaped

  if(!options.injection || options.injection==UNESCAPED) {

    IMPRIME("[ 2.%d.1 ] Testing Unescaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    au=assemble_url(cu, num, " and 21=21");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.2 ] Confirming Unescaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, " and 67=89");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.3 ] ReConfirming Unescaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, " and NoVale");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' IS UNESCAPED INJECTABLE\n", variable_name(cu, num));
          return UNESCAPED;
          }
        }

      }

    }


  // 2) Single_Quote

  if(!options.injection || options.injection==SINGLE_QUOTE) {

    IMPRIME("[ 2.%d.4 ] Testing Single_Quote Escaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    au=assemble_url(cu, num, "' and '21'='21");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.5 ] Confirming Single_Quote Escaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, "' and '67'='89");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.6 ] ReConfirming Single_Quote Escaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, "' and NoVale");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' IS SINGLE_QUOTE ESCAPED INJECTABLE\n", variable_name(cu, num));
          return SINGLE_QUOTE;
          }

        }

      }

    }


  // 3) Double_quotes

  if(!options.injection || options.injection==DOUBLE_QUOTES) {

    IMPRIME("[ 2.%d.7 ] Testing Double_Quotes Escaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    au=assemble_url(cu, num, "\" and \"21\"=\"21");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.8 ] Confirming Double_Quotes Escaped Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, "\" and \"67\"=\"89");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.9 ] ReConfirming Double_Quotes Escaped in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, "\" and NoVale");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-2;
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' DOUBLE_QUOTES ESCAPED INJECTABLE\n", variable_name(cu, num));
          return DOUBLE_QUOTES;
          }

        }

      }

    }


  // 4) Numeric

  if(!options.injection || options.injection==NUMERIC) {

    IMPRIME("[ 2.%d.10 ] Testing Numeric Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    au=assemble_url(cu, num, "-21+21*01");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.11 ] Confirming Numeric Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, "-21");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.12 ] ReConfirming Numeric Inject in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, "-NoVale");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' IS NUMERIC INJECTABLE\n", variable_name(cu, num));
          return NUMERIC;
          }

        }

      }

    }


  // 5) String_concat_pipe: Oracle, DB2, postgres, informix, sqlite, pointbase

  if(!options.injection || options.injection==STRING_CONCAT_PIPE) {

    IMPRIME("[ 2.%d.13 ] Testing String_Concat_Pipe Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    au=assemble_url(cu, num, "'||lower('')||'");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.14 ] Confirming String_Concat_Pipe Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, "'||'21");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.15 ] ReConfirming String_Concat_Pipe Inject in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, "'||Novale");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' IS STRING_CONCAT_PIPE INJECTABLE\n", variable_name(cu, num));
          return STRING_CONCAT_PIPE;
          }

        }

      }

    }


  // 6) String_concat_plus: Mysql?, MSSQL, Sybase, access

  if(!options.injection || options.injection==STRING_CONCAT_PLUS) {

    IMPRIME("[ 2.%d.16 ] Testing String_Concat_Plus Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    au=assemble_url(cu, num, "'+rtrim('')+'");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.17 ] Confirming String_Concat_Plus Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, "'+'21");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.18 ] ReConfirming String_Concat_Plus Inject in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, "'+Novale");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' IS STRING_CONCAT_PLUS INJECTABLE\n", variable_name(cu, num));
          return STRING_CONCAT_PLUS;
          }

        }

      }

    }


  // 8) Time_delay: MSSQL, Postgress
  // -> depende de la bbdd

  if(options.injection==TIME_DELAY) {

    }


  // 7) Select_case_numeric: Very alpha code
  // SI: mssqlserver, oracle, db2, postgres
  // NO: mysql

  if(options.injection==SELECT_CASE_NUMERIC) {
    struct assembled_url url;
    struct result resultado;
    int comparacion=0;
    int i;


    IMPRIME("[ 2.%d.16 ] Testing Select_Case_Numeric Inject in Parameter: '%s'\n", num, variable_name(cu, num));

    ///////////////////////////////////////////////////////////////////////////////////
    // -(select case when 1=1 then 1/0 else 0 end) -> ok2
    // -(select case when NoVale=QueNo then 1/0 else 0 end) -> error
    // -0 => -(select case when 1=2 then 1/0 else 0 end) -> error
    // -> habria que hacerlo despues de fingerprint => chapuza generica follows

    url=assemble_url(cu, num, "-(1/0)");
    resultado=get_url(url); free(url.url); free(url.post);
    base_result=resultado;

    url=assemble_url(cu, num, "-(0)");
    resultado=get_url(url); free(url.url); free(url.post);
    base_error=resultado;

    url=assemble_url(cu, num, "-(NoVale)");
    resultado=get_url(url); free(url.url); free(url.post);

    for(i=0;i<resultado.word_count;i++) {
      strncpy(base_error.word_list[base_error.word_count], resultado.word_list[i], WORD_SIZE-1);
      if(base_error.word_count>LIST_SIZE-2) i=resultado.word_count;
      else base_error.word_count++; }

    if(options.debuging==9) IMPRIME("+ isinject() WORD_COUNT: %d\n", base_error.word_count);

    qsort(base_error.word_list, base_error.word_count, WORD_SIZE, (void *)strcmp);
    strncpy(key_word, get_diferent(base_result.word_list, base_error.word_list, base_result.word_count, base_error.word_count), WORD_SIZE-1);

    if(options.debuging>1) IMPRIME("+ isinject() SELECT_CASE_NUMERIC(key_word): %s\n", key_word);

    ///////////////////////////////////////////////////////////////////////////////////


    au=assemble_url(cu, num, "-(21/0)");
    resultado=get_url(au); free(au.url); free(au.post);

    if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
    if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
    if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

    if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {

      IMPRIME("[ 2.%d.17 ] Confirming Select_Case_Numeric Inject in Parameter: '%s'\n", num, variable_name(cu, num));

      au=assemble_url(cu, num, "-(67-67)");
      resultado=get_url(au); free(au.url); free(au.post);

      if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
      if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
      if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

      if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {

        IMPRIME("[ 2.%d.18 ] ReConfirming Select_Case_Numeric Inject in Parameter: '%s'\n", num, variable_name(cu, num));

        au=assemble_url(cu, num, "-(Pues-Na)");
        resultado=get_url(au); free(au.url); free(au.post);

        base_error=resultado;

        if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words);
        if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
        if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

        if(resultado.codigo_http!=base_result.codigo_http || comparacion>0) {
          IMPRIME("==> PARAMETER '%s' IS SELECT_CASE_NUMERIC INJECTABLE\n", variable_name(cu, num));
          return SELECT_CASE_NUMERIC;
          }

        }

      }

    }


  // Order BY ????


  IMPRIME("--> PARAMETER '%s' IS NOT INJECTABLE\n", variable_name(cu, num));
  return 0;

}


