/*
 * <match.c>
 */


#include "sqlibf.h"
#include "err2db.h"
#include <regex.h>



//
// SEARCH _____________________________________________________________________
//
// Uso: Busca un mensaje de error SQL en una cadena
//

int search(char *string) {
  int i=0;

  while(err2db[i].code!=0xff) {
    if(match(string, err2db[i].string)) return err2db[i].code;
    i++;
  }

  return 0;

}


//
// MATCH ______________________________________________________________________
//
// Uso: Busca un patron dado en una cadena
//

int match(char *string, char *pattern) {
  int status;
  regex_t re;

  if(regcomp(&re, pattern, REG_EXTENDED|REG_NOSUB) != 0) {
    return(0);      /* report error */
  }

  status = regexec(&re, string, (size_t) 0, NULL, 0);

  regfree(&re);

  if(status != 0) {
    return(0);      /* report error */
  }

  return(1);

}


