/*
 * <utils.c>
 */

#include "sqlibf.h"


//
// CODE2STRING ________________________________________________________________
//
// Uso: Muestra la cadena correspondiente a un codigo dado
//

char *code2string(struct array *a, int v) {
  int i=0;

  while(a[i].code!=v && a[i].code!=0xff) {
  i++;
  }

  return a[i].string;

}


//
// URI_ENCODE _________________________________________________________________
//
// Uso: Codifica mediante URI enconding una cadena
//

char *uri_encode(char *string) {
  char *my_string;
  char *ptr;
  char *my_ptr;
  char *fin;

  my_string=malloc(STRING_SIZE); memset(my_string, 0, STRING_SIZE);

  ptr=string;
  fin=ptr+strlen(string);
  my_ptr=my_string;

  while(ptr<fin) {
    if(*ptr==' ') {
      // 0 -> all encoded
      if(options.uri_encode_data==1) { strncpy(my_ptr, "%20", 3); my_ptr+=3; }
      else if(options.uri_encode_data==2) { strncpy(my_ptr, "%09", 3); my_ptr+=3; } // Tab-encoded
      else if(options.uri_encode_data==3) { strncpy(my_ptr, "\t", 1); my_ptr+=1; } // Tab
      else if(options.uri_encode_data==4) { strncpy(my_ptr, "/*X*/", 5); my_ptr+=5; } // No compatible con DB2, Informix
      //else { strncpy(my_ptr, " ", 1); my_ptr+=1; }
    }

    // OJO: meter switch?

    // Basic
    else if(*ptr=='=' && options.uri_encode_data<4) { strncpy(my_ptr, "%3D", 3); my_ptr+=3; }
    else if(*ptr=='&' && options.uri_encode_data<4) { strncpy(my_ptr, "%26", 3); my_ptr+=3; }
    // Basic URL (OJO: Post no)
    else if(*ptr=='?' && options.uri_encode_data<4) { strncpy(my_ptr, "%3F", 3); my_ptr+=3; }
    else if(*ptr==';' && options.uri_encode_data<4) { strncpy(my_ptr, "%3B", 3); my_ptr+=3; }
    // Recomendable
    else if(*ptr=='+' && options.uri_encode_data<3) { strncpy(my_ptr, "%2B", 3); my_ptr+=3; }
    else if(*ptr=='#' && options.uri_encode_data<3) { strncpy(my_ptr, "%23", 3); my_ptr+=3; }
    else if(*ptr=='~' && options.uri_encode_data<3) { strncpy(my_ptr, "%7E", 3); my_ptr+=3; }
    else if(*ptr=='$' && options.uri_encode_data<3) { strncpy(my_ptr, "%24", 3); my_ptr+=3; }
    // Paranoid
    else if(*ptr=='(' && options.uri_encode_data<1) { strncpy(my_ptr, "%28", 3); my_ptr+=3; }
    else if(*ptr==')' && options.uri_encode_data<1) { strncpy(my_ptr, "%29", 3); my_ptr+=3; }
    else if(*ptr=='<' && options.uri_encode_data<1) { strncpy(my_ptr, "%3C", 3); my_ptr+=3; }
    else if(*ptr=='>' && options.uri_encode_data<1) { strncpy(my_ptr, "%3E", 3); my_ptr+=3; }
    else if(*ptr==',' && options.uri_encode_data<1) { strncpy(my_ptr, "%2C", 3); my_ptr+=3; }
    else if(*ptr=='-' && options.uri_encode_data<1) { strncpy(my_ptr, "%2D", 3); my_ptr+=3; }
    else if(*ptr=='/' && options.uri_encode_data<1) { strncpy(my_ptr, "%2F", 3); my_ptr+=3; }
    else if(*ptr=='*' && options.uri_encode_data<1) { strncpy(my_ptr, "%2A", 3); my_ptr+=3; }
    // Otra cosa...
    else { strncpy(my_ptr, ptr, 1); my_ptr++; }

    ptr++;

  }

  return my_string;

}


//
// CHECK_URL _________________________________________________________________
//
// Uso: Comprueba si la cadena dada es una url valida
//

int check_url(char *url) {

  if(strncmp(url, "http://", 7)!=0 && strncmp(url, "https://", 8)!=0) {
    IMPRIME("\n==> ERROR: Invalid URL format\n");
    IMPRIME(" (Use: http://url or https://url for SSL)\n");
    return -1;
  }

  if(strlen(url)>STRING_SIZE) {
    IMPRIME("\n==> ERROR: URL too long\n");
    return -1;
  }

  return 0;

}


//
// COMPARE_WORDS _________________________________________________________________
//
// Uso: Compara 2 listas de palabras y aade las coincidencias a la lista "base_result.word_list"
//

int compare_words(char list1[LIST_SIZE][WORD_SIZE], char list2[LIST_SIZE][WORD_SIZE], int count1, int count2) {
  void *result;
  int i;
  int word_count=0;
  char tmp_list[LIST_SIZE][WORD_SIZE];

  for(i=0;i<count1;i++) {
    result=bsearch(list1[i], list2, count2, WORD_SIZE, (void *)strcmp);
    if(result) {
      strncpy(tmp_list[word_count], list1[i], WORD_SIZE-1);
      word_count++;
    }
  }

  memset(tmp_list[word_count], 0, (LIST_SIZE-word_count)*WORD_SIZE);

  memcpy(base_result.word_list,tmp_list,LIST_SIZE*WORD_SIZE);
  base_result.word_count=word_count;

  if(options.debuging>3) IMPRIME("+++ compare_words() COINCIDENCES = %d\n", word_count);

  if(options.debuging==31) IMPRIME("++++++ main() Compared array: %d\n", word_count);
  if(options.debuging==31) for(i=0; i<word_count; i++) IMPRIME("++++++ %s\n",base_result.word_list[i]);

  return word_count;

}


//
// GET_DIFERENT _________________________________________________________________
//
// Uso: Compara 2 listas de palabras y devuelve la primera palabra que no se repite
//

char *get_diferent(char list1[LIST_SIZE][WORD_SIZE], char list2[LIST_SIZE][WORD_SIZE], int count1, int count2) {
  void *result;
  int i;

  if(options.debuging==9) for(i=0;i<count2;i++) IMPRIME("+ get_diferent(%d) WORD2: '%s'\n", i, list2[i]);

  for(i=0;i<count1;i++) {
    if(options.debuging==9) IMPRIME("+ get_diferent(%d) WORD1: '%s'\n", i, list1[i]);
    result=bsearch(list1[i], list2, count2, WORD_SIZE, (void *)strcmp);
    if(result==0) return list1[i];
    }

return "";

}


//
// IS_INLIST _________________________________________________________________
//
// Uso: Comprueba si la palabra dada esta en una lista
//

int is_inlist(char word[WORD_SIZE], char list1[LIST_SIZE][WORD_SIZE], int count) {
  void *result;

  result=bsearch(word, list1, count, WORD_SIZE, (void *)strcmp);

  if(result) {
    if(options.debuging>1) IMPRIME("+ is_inlist() KEY FOUND: %s\n", word);
    return 0;
    }

  return 1;

}


//
// SPACES_COUNT _________________________________________________________________
//
// Uso: Cuenta los espacios que hay en una cadena
//

int spaces_count(char *cadena) {
  int result=0;
  char *ptr;

  for(ptr=cadena;ptr<cadena+strlen(cadena);ptr++) if(*ptr==' ') result++;

  return result;

}







